// MODULE: Exo1.java
// PROGRAMMEUR: IFT 1170
// OBJET DEMO5 : une classe Ensemble
// NOTE: il existe de nombreuses facons de coder ce programme
//       celle-ci n'en est qu'une parmi d'autres


class Ensemble {
  private final int MAX = 256;
  private boolean ensemble[] = new boolean [MAX]; // l'ensemble

  // constructeur qui met ensemble a false
  // note : en pratique le tableau est deja alloue a false, mais par convention...
  Ensemble() {
    for (int i=0; i<MAX; i++)
      ensemble[i] = false;
  }

  // methode qui ajoute val dans l'ensemble
  public void ajoute(int val) {
    if ((val >=0) && (val <MAX))
      ensemble[val] = true;
    else
      System.err.println("val est superieur a " + MAX + ", le plus grand entier supporte");
  }

  public void supprime(int val) {
    if ((val >=0) && (val <MAX)) ensemble[val] = false;
  }

  public int getSize() {
    int nb=0;
    for (int i=0; i<MAX; i++)
      if (ensemble[i]) nb++;
    return nb;
  }

  public boolean appartient(int val) {
   if ((val >=0) && (val <MAX)) return ensemble[val];
   // on passe ici uniqt si val est en dehors des limites de la table
   return false;
  }

  // NOTE: e.ensemble marche alors que ensemble est un membre prive
  // En Java, un objet de la meme classe que la classe peut acceder
  // a ses variables privees

  public Ensemble complement() {
    Ensemble e = new Ensemble();
    for (int i=0; i<MAX; i++)
      e.ensemble[i] = ! ensemble[i];
    return e;
  }

  public Ensemble intersection(Ensemble e) {
    Ensemble n = new Ensemble();
    for (int i=0; i<MAX; i++)
       if (e.appartient(i) &&  this.appartient(i))
        n.ajoute(i);
    return n;
  }

  public Ensemble union (Ensemble e ) {
    Ensemble n = new Ensemble();
    for (int i=0; i<MAX; i++)
      if (e.appartient(i) || this.appartient(i))
        n.ajoute(i);

    return n;
  }

  public boolean egalite (Ensemble e) {
    for (int i=0; i<MAX; i++)
      if (e.ensemble[i] != this.ensemble[i])
       return false;
    // tous les elts sont egaux
    return true;
  }


  public boolean inclus (Ensemble e) {
    for (int i=0; i<MAX; i++)
      if (! appartient(i)) return false;
    // tous les elts de e sont dans this
    return true;
  }

  // ce que fait toString ici est simplemnt de retourner une chaine (String)
  // avec tous les elts de la table
  public String toString () {
    StringBuffer s = new StringBuffer("{ ");

    for (int i=0; i<MAX; i++)
      if (ensemble[i])
        s.append(i).append(" ");
      return s.append("}").toString();
  }

}

public class Exo1 {

  public static void main(String args[]) {
    Ensemble s1 = new Ensemble();
    Ensemble s2 = new Ensemble();

    for (int i=0; i<10; i++) {
      s1.ajoute((int) (Math.random()*256));
      s2.ajoute((int) (Math.random()*256));
    }
    System.out.println("s1="+s1);
    System.out.println("s2="+s2);

    System.out.println("complement(s1)="+s1.complement());
    System.out.println("inter(s1,s2)="+s1.intersection(s2));
    System.out.println("union(s1,s2)="+s1.union(s2));
    System.out.println("nb elt dans l'union: "+s1.union(s2).getSize());
    System.out.println("nb elt dans l'intersection: "+s1.intersection(s2).getSize());
    System.out.println("egal(s1,s1)="+s1.egalite(s1));

    System.out.println("le complement du complement est-il l'ensemble de depart : "+
      ((s1.complement().complement().egalite(s1))? "OUI":"NON"));
  }
}
